module.exports = (function() {
  /*
   * Generated by PEG.js 0.8.0.
   *
   * http://pegjs.majda.cz/
   */

  function peg$subclass(child, parent) {
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor();
  }

  function SyntaxError(message, expected, found, offset, line, column) {
    this.message  = message;
    this.expected = expected;
    this.found    = found;
    this.offset   = offset;
    this.line     = line;
    this.column   = column;

    this.name     = "SyntaxError";
  }

  peg$subclass(SyntaxError, Error);

  function parse(input) {
    var options = arguments.length > 1 ? arguments[1] : {},

        peg$FAILED = {},

        peg$startRuleIndices = { start: 0, attrValue: 10, attrArguments: 11, pathQuery: 21, path: 23 },
        peg$startRuleIndex   = 0,

        peg$consts = [
          function(html) {
          	return {
          		type: NODE_TYPE.ROOT,
          		children: html,
          		version: Mustache.VERSION
          	}
          },
          [],
          function(nodes) { return _.compact(nodes); },
          peg$FAILED,
          /^[^<{]/,
          { type: "class", value: "[^<{]", description: "[^<{]" },
          function(text) { return { type: NODE_TYPE.TEXT, value: text.join("") }; },
          "<!--",
          { type: "literal", value: "<!--", description: "\"<!--\"" },
          "-->",
          { type: "literal", value: "-->", description: "\"-->\"" },
          function(v) {
          		return { type: NODE_TYPE.XCOMMENT, value: v.trim() };
          	},
          void 0,
          { type: "any", description: "any character" },
          null,
          function(l, r) { return l + (r != null ? r : ""); },
          function(start, nodes, end) {
          		if (start.name.toLowerCase() !== end.toLowerCase()) {
          			throw new Error("Element tag mismatch: " + start.name + " !== " + end);
          		}

          		start.type = NODE_TYPE.ELEMENT;
          		start.children = nodes;
          		return start;
          	},
          "<",
          { type: "literal", value: "<", description: "\"<\"" },
          "/>",
          { type: "literal", value: "/>", description: "\"/>\"" },
          function(tagname, attributes) {
          		return {
          			name: tagname,
          			type: NODE_TYPE.ELEMENT,
          			attributes: attributes,
          			children: []
          		}
          	},
          ">",
          { type: "literal", value: ">", description: "\">\"" },
          function(tagname, attributes) {
          		return { name: tagname, attributes: attributes };
          	},
          "</",
          { type: "literal", value: "</", description: "\"</\"" },
          function(tagname) { return tagname; },
          "=",
          { type: "literal", value: "=", description: "\"=\"" },
          function(key, value) {
          		value = value != null ? value[2] : "";
          		
          		return {
          			type: NODE_TYPE.ATTRIBUTE,
          			name: key,
          			value: value,
          			children: parse(value, _.extend({}, options, { startRule: "attrValue" })),
          			arguments: parse(value,  _.extend({}, options, { startRule: "attrArguments" }))
          		}
          	},
          ",",
          { type: "literal", value: ",", description: "\",\"" },
          function(l, r) { return r != null && r[1] != null ? [l].concat(r[1]) : [l]; },
          function(v) { return v; },
          /^[^,]/,
          { type: "class", value: "[^,]", description: "[^,]" },
          function(v) { return v.trim(); },
          function(val) {
          		if (_.isObject(val)) return val;
          		else return { type: NODE_TYPE.LITERAL, value: val };
          	},
          /^[,]/,
          { type: "class", value: "[,]", description: "[,]" },
          function(start, nodes, end) {
          		if (options.strict && !_.isEqual(start.value.raw, end)) {
          			throw new Error("Section tag mismatch: " + start.value.raw + " !== " + end);
          		}

          		start.value = start.value.result;
          		start.children = nodes;
          		return start;
          	},
          "{{",
          { type: "literal", value: "{{", description: "\"{{\"" },
          /^[#\^]/,
          { type: "class", value: "[#\\^]", description: "[#\\^]" },
          "}}",
          { type: "literal", value: "}}", description: "\"}}\"" },
          function(type, value) {
          		return {
          			type: NODE_TYPE[type === "#" ? "SECTION" : "INVERTED"],
          			value: value
          		}
          	},
          "{{/",
          { type: "literal", value: "{{/", description: "\"{{/\"" },
          /^[^}]/,
          { type: "class", value: "[^}]", description: "[^}]" },
          function(value) { return value.join(""); },
          "{{{",
          { type: "literal", value: "{{{", description: "\"{{{\"" },
          "}}}",
          { type: "literal", value: "}}}", description: "\"}}}\"" },
          function(value) {
          		return {
          			type: NODE_TYPE.INTERPOLATOR,
          			value: value[1]
          		}
          	},
          /^[\/#{!>\^]/,
          { type: "class", value: "[\\/#{!>\\^]", description: "[\\/#{!>\\^]" },
          "&",
          { type: "literal", value: "&", description: "\"&\"" },
          function(m, value) {
          		return {
          			type: m ? NODE_TYPE.TRIPLE : NODE_TYPE.INTERPOLATOR,
          			value: value
          		}
          	},
          function(value) {
          		return {
          			type: NODE_TYPE.TRIPLE,
          			value: value
          		}
          	},
          /^[!>]/,
          { type: "class", value: "[!>]", description: "[!>]" },
          function(m, value) {
          		return {
          			type: m === ">" ? NODE_TYPE.PARTIAL : NODE_TYPE.MCOMMENT,
          			value: value.join("").trim()
          		}
          	},
          "|",
          { type: "literal", value: "|", description: "\"|\"" },
          function(m) { return { raw: text(), result: m } },
          function(p, c) {
          		if (p == null) p = { type: "all" };
          		p.parts = c;
          		return p;
          	},
          function(p) { p.parts = []; return p; },
          "../",
          { type: "literal", value: "../", description: "\"../\"" },
          function(d) { return { type: "parent", distance: d.length }; },
          "./",
          { type: "literal", value: "./", description: "\"./\"" },
          function() { return { type: "local" }; },
          ".",
          { type: "literal", value: ".", description: "\".\"" },
          "/",
          { type: "literal", value: "/", description: "\"/\"" },
          function() { return { type: "root" }; },
          /^[a-z0-9$_]/i,
          { type: "class", value: "[a-z0-9$_]i", description: "[a-z0-9$_]i" },
          /^[a-z0-9:\-_$]/i,
          { type: "class", value: "[a-z0-9:\\-_$]i", description: "[a-z0-9:\\-_$]i" },
          function(k, c) { return { key: k, children: c } },
          "[",
          { type: "literal", value: "[", description: "\"[\"" },
          "]",
          { type: "literal", value: "]", description: "\"]\"" },
          function(c) { return c; },
          "true",
          { type: "literal", value: "true", description: "\"true\"" },
          function() { return true; },
          "false",
          { type: "literal", value: "false", description: "\"false\"" },
          function() { return false; },
          "-",
          { type: "literal", value: "-", description: "\"-\"" },
          /^[0-9]/,
          { type: "class", value: "[0-9]", description: "[0-9]" },
          function() { return parseFloat(text(), 10); },
          function() { return parseInt(text(), 10); },
          "\"",
          { type: "literal", value: "\"", description: "\"\\\"\"" },
          /^[^"]/,
          { type: "class", value: "[^\"]", description: "[^\"]" },
          function(v) { return v.join(""); },
          "'",
          { type: "literal", value: "'", description: "\"'\"" },
          /^[^']/,
          { type: "class", value: "[^']", description: "[^']" },
          "null",
          { type: "literal", value: "null", description: "\"null\"" },
          function() { return null; },
          "undefined",
          { type: "literal", value: "undefined", description: "\"undefined\"" },
          "void",
          { type: "literal", value: "void", description: "\"void\"" },
          /^[,; \t\n\r]/,
          { type: "class", value: "[,; \\t\\n\\r]", description: "[,; \\t\\n\\r]" },
          function() { return void 0; },
          /^[a-z0-9_\-]/i,
          { type: "class", value: "[a-z0-9_\\-]i", description: "[a-z0-9_\\-]i" },
          function(k) { return k; },
          { type: "other", description: "whitespace" },
          /^[ \t\n\r]/,
          { type: "class", value: "[ \\t\\n\\r]", description: "[ \\t\\n\\r]" },
          "\\",
          { type: "literal", value: "\\", description: "\"\\\\\"" },
          function(char) { return char; }
        ],

        peg$bytecode = [
          peg$decode("!7!+' 4!6 !! %"),
          peg$decode("! !7.*A \"74*; \"72*5 \"73*/ \"7#*) \"7%*# \"7\",G&7.*A \"74*; \"72*5 \"73*/ \"7#*) \"7%*# \"7\"\"+' 4!6\"!! %"),
          peg$decode("! !0$\"\"1!3%+,$,)&0$\"\"1!3%\"\"\" #+' 4!6&!! %"),
          peg$decode("!.'\"\"2'3(+B$7$+8%.)\"\"2)3*+(%4#6+#!!%$## #$\"# #\"# #"),
          peg$decode("!8.)\"\"2)3*9+$$\"# ,\"\" #*I \"!-\"\"1!3-+9$7$*# \" .+)%4\"6/\"\"! %$\"# #\"# #"),
          peg$decode("7&*I \"!7'+>$7!+4%7(+*%4#60##\"! %$## #$\"# #\"# #"),
          peg$decode("!.1\"\"2132+U$7C+K% !7),#&7)\"+9%.3\"\"2334+)%4$65$\"\"!%$$# #$## #$\"# #\"# #"),
          peg$decode("!.1\"\"2132+U$7C+K% !7),#&7)\"+9%.6\"\"2637+)%4$68$\"\"!%$$# #$## #$\"# #\"# #"),
          peg$decode("!.9\"\"293:+B$7C+8%.6\"\"2637+(%4#6;#!!%$## #$\"# #\"# #"),
          peg$decode("!7C+h$!.<\"\"2<3=+A$7D+7%7@+-%7D+#%'$%$$# #$## #$\"# #\"# #*# \" .+)%4\"6>\"\"! %$\"# #\"# #"),
          peg$decode("! !7.*5 \"74*/ \"72*) \"73*# \"7\",;&7.*5 \"74*/ \"72*) \"73*# \"7\"\"+' 4!6\"!! %"),
          peg$decode("!7,+T$!.?\"\"2?3@+-$7++#%'\"%$\"# #\"# #*# \" .+)%4\"6A\"\"! %$\"# #\"# #"),
          peg$decode("!!7D+F$71+<%7D+2%7-+(%4$6B$!\"%$$# #$## #$\"# #\"# #*\u014D \"!7D+F$7?+<%7D+2%7-+(%4$6B$!\"%$$# #$## #$\"# #\"# #*\u0119 \"!7D+F$7<+<%7D+2%7-+(%4$6B$!\"%$$# #$## #$\"# #\"# #*\xE5 \"!7D+F$7=+<%7D+2%7-+(%4$6B$!\"%$$# #$## #$\"# #\"# #*\xB1 \"!7D+F$7A+<%7D+2%7-+(%4$6B$!\"%$$# #$## #$\"# #\"# #*} \"!7D+F$7B+<%7D+2%7-+(%4$6B$!\"%$$# #$## #$\"# #\"# #*I \"!! !0C\"\"1!3D,)&0C\"\"1!3D\"+! (%+' 4!6E!! %+' 4!6F!! %"),
          peg$decode("!80G\"\"1!3H*6 \"!8-\"\"1!3-9*$$\"\" ,\"# #9+$$\"# ,\"\" #"),
          peg$decode("!7/+>$7!+4%70+*%4#6I##\"! %$## #$\"# #\"# #"),
          peg$decode("!.J\"\"2J3K+S$0L\"\"1!3M+C%76+9%.N\"\"2N3O+)%4$6P$\"\"!%$$# #$## #$\"# #\"# #"),
          peg$decode("!.Q\"\"2Q3R+b$ !7E*) \"0S\"\"1!3T,/&7E*) \"0S\"\"1!3T\"+8%.N\"\"2N3O+(%4#6U#!!%$## #$\"# #\"# #"),
          peg$decode("!!.V\"\"2V3W+=$75+3%.X\"\"2X3Y+#%'#%$## #$\"# #\"# #*N \"!.J\"\"2J3K+=$75+3%.N\"\"2N3O+#%'#%$## #$\"# #\"# #+' 4!6Z!! %"),
          peg$decode("!.J\"\"2J3K+w$!80[\"\"1!3\\9*$$\"\" ,\"# #+Y%.]\"\"2]3^*# \" .+C%75+9%.N\"\"2N3O+)%4%6_%\"\"!%$%# #$$# #$## #$\"# #\"# #"),
          peg$decode("!.V\"\"2V3W+B$75+8%.X\"\"2X3Y+(%4#6`#!!%$## #$\"# #\"# #"),
          peg$decode("!.J\"\"2J3K+s$0a\"\"1!3b+c% !7E*) \"0S\"\"1!3T,/&7E*) \"0S\"\"1!3T\"+9%.N\"\"2N3O+)%4$6c$\"\"!%$$# #$## #$\"# #\"# #"),
          peg$decode("!77+T$!.d\"\"2d3e+-$75+#%'\"%$\"# #\"# #*# \" .+)%4\"6A\"\"! %$\"# #\"# #"),
          peg$decode("!75+' 4!6f!! %"),
          peg$decode("!7D+M$78*# \" .+=%79+3%7D+)%4$6g$\"\"!%$$# #$## #$\"# #\"# #*G \"!7D+<$78+2%7D+(%4#6h#!!%$## #$\"# #\"# #"),
          peg$decode("! !.i\"\"2i3j+,$,)&.i\"\"2i3j\"\"\" #+' 4!6k!! %*b \"!.l\"\"2l3m+& 4!6n! %*K \"!.o\"\"2o3p+& 4!6n! %*4 \"!.q\"\"2q3r+& 4!6s! %"),
          peg$decode("!7:+T$!.o\"\"2o3p+-$79+#%'\"%$\"# #\"# #*# \" .+)%4\"6A\"\"! %$\"# #\"# #"),
          peg$decode("!!!0t\"\"1!3u+A$ !0v\"\"1!3w,)&0v\"\"1!3w\"+#%'\"%$\"# #\"# #+! (%+;$ !7;,#&7;\"+)%4\"6x\"\"! %$\"# #\"# #"),
          peg$decode("!.y\"\"2y3z+b$7D+X%7>*) \"7?*# \"77+B%7D+8%.{\"\"2{3|+(%4%6}%!\"%$%# #$$# #$## #$\"# #\"# #"),
          peg$decode("!.~\"\"2~3+& 4!6\x80! %*4 \"!.\x81\"\"2\x813\x82+& 4!6\x83! %"),
          peg$decode("!.\x84\"\"2\x843\x85*# \" .+\x92$ !0\x86\"\"1!3\x87+,$,)&0\x86\"\"1!3\x87\"\"\" #+m%!.o\"\"2o3p+H$ !0\x86\"\"1!3\x87+,$,)&0\x86\"\"1!3\x87\"\"\" #+#%'\"%$\"# #\"# #*# \" .+'%4#6\x88# %$## #$\"# #\"# #"),
          peg$decode("! !0\x86\"\"1!3\x87+,$,)&0\x86\"\"1!3\x87\"\"\" #+& 4!6\x89! %"),
          peg$decode("!.\x8A\"\"2\x8A3\x8B+b$ !7E*) \"0\x8C\"\"1!3\x8D,/&7E*) \"0\x8C\"\"1!3\x8D\"+8%.\x8A\"\"2\x8A3\x8B+(%4#6\x8E#!!%$## #$\"# #\"# #*s \"!.\x8F\"\"2\x8F3\x90+b$ !7E*) \"0\x91\"\"1!3\x92,/&7E*) \"0\x91\"\"1!3\x92\"+8%.\x8F\"\"2\x8F3\x90+(%4#6\x8E#!!%$## #$\"# #\"# #"),
          peg$decode("!.\x8A\"\"2\x8A3\x8B+\\$! !0\x8C\"\"1!3\x8D,)&0\x8C\"\"1!3\x8D\"+! (%+8%.\x8A\"\"2\x8A3\x8B+(%4#6B#!!%$## #$\"# #\"# #*m \"!.\x8F\"\"2\x8F3\x90+\\$! !0\x91\"\"1!3\x92,)&0\x91\"\"1!3\x92\"+! (%+8%.\x8F\"\"2\x8F3\x90+(%4#6B#!!%$## #$\"# #\"# #"),
          peg$decode("!.\x93\"\"2\x933\x94+& 4!6\x95! %"),
          peg$decode("!.\x96\"\"2\x963\x97*q \"!.\x98\"\"2\x983\x99+`$7D+V%!8 !0\x9A\"\"1!3\x9B+,$,)&0\x9A\"\"1!3\x9B\"\"\" #9*$$\"\" ,\"# #+#%'#%$## #$\"# #\"# #+& 4!6\x9C! %"),
          peg$decode("!7D+]$! !0\x9D\"\"1!3\x9E+,$,)&0\x9D\"\"1!3\x9E\"\"\" #+! (%+2%7D+(%4#6\x9F#!!%$## #$\"# #\"# #"),
          peg$decode("8! !0\xA1\"\"1!3\xA2,)&0\xA1\"\"1!3\xA2\"+! (%9*\" 3\xA0"),
          peg$decode("!.\xA3\"\"2\xA33\xA4+7$-\"\"1!3-+(%4\"6\xA5\"! %$\"# #\"# #")
        ],

        peg$currPos          = 0,
        peg$reportedPos      = 0,
        peg$cachedPos        = 0,
        peg$cachedPosDetails = { line: 1, column: 1, seenCR: false },
        peg$maxFailPos       = 0,
        peg$maxFailExpected  = [],
        peg$silentFails      = 0,

        peg$result;

    if ("startRule" in options) {
      if (!(options.startRule in peg$startRuleIndices)) {
        throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
      }

      peg$startRuleIndex = peg$startRuleIndices[options.startRule];
    }

    function text() {
      return input.substring(peg$reportedPos, peg$currPos);
    }

    function offset() {
      return peg$reportedPos;
    }

    function line() {
      return peg$computePosDetails(peg$reportedPos).line;
    }

    function column() {
      return peg$computePosDetails(peg$reportedPos).column;
    }

    function expected(description) {
      throw peg$buildException(
        null,
        [{ type: "other", description: description }],
        peg$reportedPos
      );
    }

    function error(message) {
      throw peg$buildException(message, null, peg$reportedPos);
    }

    function peg$computePosDetails(pos) {
      function advance(details, startPos, endPos) {
        var p, ch;

        for (p = startPos; p < endPos; p++) {
          ch = input.charAt(p);
          if (ch === "\n") {
            if (!details.seenCR) { details.line++; }
            details.column = 1;
            details.seenCR = false;
          } else if (ch === "\r" || ch === "\u2028" || ch === "\u2029") {
            details.line++;
            details.column = 1;
            details.seenCR = true;
          } else {
            details.column++;
            details.seenCR = false;
          }
        }
      }

      if (peg$cachedPos !== pos) {
        if (peg$cachedPos > pos) {
          peg$cachedPos = 0;
          peg$cachedPosDetails = { line: 1, column: 1, seenCR: false };
        }
        advance(peg$cachedPosDetails, peg$cachedPos, pos);
        peg$cachedPos = pos;
      }

      return peg$cachedPosDetails;
    }

    function peg$fail(expected) {
      if (peg$currPos < peg$maxFailPos) { return; }

      if (peg$currPos > peg$maxFailPos) {
        peg$maxFailPos = peg$currPos;
        peg$maxFailExpected = [];
      }

      peg$maxFailExpected.push(expected);
    }

    function peg$buildException(message, expected, pos) {
      function cleanupExpected(expected) {
        var i = 1;

        expected.sort(function(a, b) {
          if (a.description < b.description) {
            return -1;
          } else if (a.description > b.description) {
            return 1;
          } else {
            return 0;
          }
        });

        while (i < expected.length) {
          if (expected[i - 1] === expected[i]) {
            expected.splice(i, 1);
          } else {
            i++;
          }
        }
      }

      function buildMessage(expected, found) {
        function stringEscape(s) {
          function hex(ch) { return ch.charCodeAt(0).toString(16).toUpperCase(); }

          return s
            .replace(/\\/g,   '\\\\')
            .replace(/"/g,    '\\"')
            .replace(/\x08/g, '\\b')
            .replace(/\t/g,   '\\t')
            .replace(/\n/g,   '\\n')
            .replace(/\f/g,   '\\f')
            .replace(/\r/g,   '\\r')
            .replace(/[\x00-\x07\x0B\x0E\x0F]/g, function(ch) { return '\\x0' + hex(ch); })
            .replace(/[\x10-\x1F\x80-\xFF]/g,    function(ch) { return '\\x'  + hex(ch); })
            .replace(/[\u0180-\u0FFF]/g,         function(ch) { return '\\u0' + hex(ch); })
            .replace(/[\u1080-\uFFFF]/g,         function(ch) { return '\\u'  + hex(ch); });
        }

        var expectedDescs = new Array(expected.length),
            expectedDesc, foundDesc, i;

        for (i = 0; i < expected.length; i++) {
          expectedDescs[i] = expected[i].description;
        }

        expectedDesc = expected.length > 1
          ? expectedDescs.slice(0, -1).join(", ")
              + " or "
              + expectedDescs[expected.length - 1]
          : expectedDescs[0];

        foundDesc = found ? "\"" + stringEscape(found) + "\"" : "end of input";

        return "Expected " + expectedDesc + " but " + foundDesc + " found.";
      }

      var posDetails = peg$computePosDetails(pos),
          found      = pos < input.length ? input.charAt(pos) : null;

      if (expected !== null) {
        cleanupExpected(expected);
      }

      return new SyntaxError(
        message !== null ? message : buildMessage(expected, found),
        expected,
        found,
        pos,
        posDetails.line,
        posDetails.column
      );
    }

    function peg$decode(s) {
      var bc = new Array(s.length), i;

      for (i = 0; i < s.length; i++) {
        bc[i] = s.charCodeAt(i) - 32;
      }

      return bc;
    }

    function peg$parseRule(index) {
      var bc    = peg$bytecode[index],
          ip    = 0,
          ips   = [],
          end   = bc.length,
          ends  = [],
          stack = [],
          params, i;

      function protect(object) {
        return Object.prototype.toString.apply(object) === "[object Array]" ? [] : object;
      }

      while (true) {
        while (ip < end) {
          switch (bc[ip]) {
            case 0:
              stack.push(protect(peg$consts[bc[ip + 1]]));
              ip += 2;
              break;

            case 1:
              stack.push(peg$currPos);
              ip++;
              break;

            case 2:
              stack.pop();
              ip++;
              break;

            case 3:
              peg$currPos = stack.pop();
              ip++;
              break;

            case 4:
              stack.length -= bc[ip + 1];
              ip += 2;
              break;

            case 5:
              stack.splice(-2, 1);
              ip++;
              break;

            case 6:
              stack[stack.length - 2].push(stack.pop());
              ip++;
              break;

            case 7:
              stack.push(stack.splice(stack.length - bc[ip + 1], bc[ip + 1]));
              ip += 2;
              break;

            case 8:
              stack.pop();
              stack.push(input.substring(stack[stack.length - 1], peg$currPos));
              ip++;
              break;

            case 9:
              ends.push(end);
              ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

              if (stack[stack.length - 1]) {
                end = ip + 3 + bc[ip + 1];
                ip += 3;
              } else {
                end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                ip += 3 + bc[ip + 1];
              }

              break;

            case 10:
              ends.push(end);
              ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

              if (stack[stack.length - 1] === peg$FAILED) {
                end = ip + 3 + bc[ip + 1];
                ip += 3;
              } else {
                end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                ip += 3 + bc[ip + 1];
              }

              break;

            case 11:
              ends.push(end);
              ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

              if (stack[stack.length - 1] !== peg$FAILED) {
                end = ip + 3 + bc[ip + 1];
                ip += 3;
              } else {
                end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                ip += 3 + bc[ip + 1];
              }

              break;

            case 12:
              if (stack[stack.length - 1] !== peg$FAILED) {
                ends.push(end);
                ips.push(ip);

                end = ip + 2 + bc[ip + 1];
                ip += 2;
              } else {
                ip += 2 + bc[ip + 1];
              }

              break;

            case 13:
              ends.push(end);
              ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

              if (input.length > peg$currPos) {
                end = ip + 3 + bc[ip + 1];
                ip += 3;
              } else {
                end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                ip += 3 + bc[ip + 1];
              }

              break;

            case 14:
              ends.push(end);
              ips.push(ip + 4 + bc[ip + 2] + bc[ip + 3]);

              if (input.substr(peg$currPos, peg$consts[bc[ip + 1]].length) === peg$consts[bc[ip + 1]]) {
                end = ip + 4 + bc[ip + 2];
                ip += 4;
              } else {
                end = ip + 4 + bc[ip + 2] + bc[ip + 3];
                ip += 4 + bc[ip + 2];
              }

              break;

            case 15:
              ends.push(end);
              ips.push(ip + 4 + bc[ip + 2] + bc[ip + 3]);

              if (input.substr(peg$currPos, peg$consts[bc[ip + 1]].length).toLowerCase() === peg$consts[bc[ip + 1]]) {
                end = ip + 4 + bc[ip + 2];
                ip += 4;
              } else {
                end = ip + 4 + bc[ip + 2] + bc[ip + 3];
                ip += 4 + bc[ip + 2];
              }

              break;

            case 16:
              ends.push(end);
              ips.push(ip + 4 + bc[ip + 2] + bc[ip + 3]);

              if (peg$consts[bc[ip + 1]].test(input.charAt(peg$currPos))) {
                end = ip + 4 + bc[ip + 2];
                ip += 4;
              } else {
                end = ip + 4 + bc[ip + 2] + bc[ip + 3];
                ip += 4 + bc[ip + 2];
              }

              break;

            case 17:
              stack.push(input.substr(peg$currPos, bc[ip + 1]));
              peg$currPos += bc[ip + 1];
              ip += 2;
              break;

            case 18:
              stack.push(peg$consts[bc[ip + 1]]);
              peg$currPos += peg$consts[bc[ip + 1]].length;
              ip += 2;
              break;

            case 19:
              stack.push(peg$FAILED);
              if (peg$silentFails === 0) {
                peg$fail(peg$consts[bc[ip + 1]]);
              }
              ip += 2;
              break;

            case 20:
              peg$reportedPos = stack[stack.length - 1 - bc[ip + 1]];
              ip += 2;
              break;

            case 21:
              peg$reportedPos = peg$currPos;
              ip++;
              break;

            case 22:
              params = bc.slice(ip + 4, ip + 4 + bc[ip + 3]);
              for (i = 0; i < bc[ip + 3]; i++) {
                params[i] = stack[stack.length - 1 - params[i]];
              }

              stack.splice(
                stack.length - bc[ip + 2],
                bc[ip + 2],
                peg$consts[bc[ip + 1]].apply(null, params)
              );

              ip += 4 + bc[ip + 3];
              break;

            case 23:
              stack.push(peg$parseRule(bc[ip + 1]));
              ip += 2;
              break;

            case 24:
              peg$silentFails++;
              ip++;
              break;

            case 25:
              peg$silentFails--;
              ip++;
              break;

            default:
              throw new Error("Invalid opcode: " + bc[ip] + ".");
          }
        }

        if (ends.length > 0) {
          end = ends.pop();
          ip = ips.pop();
        } else {
          break;
        }
      }

      return stack[0];
    }


    	var _ = require("underscore"),
    		NODE_TYPE = require("./types"),
    		Mustache = require("./");

    	options = _.defaults(options || {}, {
    		strict: true
    	});


    peg$result = peg$parseRule(peg$startRuleIndex);

    if (peg$result !== peg$FAILED && peg$currPos === input.length) {
      return peg$result;
    } else {
      if (peg$result !== peg$FAILED && peg$currPos < input.length) {
        peg$fail({ type: "end", description: "end of input" });
      }

      throw peg$buildException(null, peg$maxFailExpected, peg$maxFailPos);
    }
  }

  return {
    SyntaxError: SyntaxError,
    parse:       parse
  };
})();